"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("./types/constants");
var main_1 = require("./stores/main");
var route_parser_1 = __importDefault(require("route-parser"));
var CallInjectedView_1 = require("./framework/CallInjectedView");
var CallInjectedController_1 = require("./framework/CallInjectedController");
var is_1 = __importDefault(require("@sindresorhus/is"));
var query_string_1 = __importDefault(require("query-string"));
var history_1 = require("./stores/history");
var storeupdator_1 = require("./stores/storeupdator");
var tock_1 = require("./framework/tock");
var promise_any_1 = require("./helpers/promise-any");
var url_join_1 = require("./helpers/url-join");
var getMetaData = Reflect.getMetadata.bind(Reflect);
var SlickApp = (function () {
    function SlickApp(container, options, target, base, Component404, history, errorPage) {
        var _this = this;
        this.container = container;
        this.options = options;
        this.target = target;
        this.base = base;
        this.Component404 = Component404;
        this.history = history;
        this.errorPage = errorPage;
        history_1.historyStore.update(function (x) { return _this.history; });
    }
    SlickApp.prototype.Initialize = function () {
        this.compile();
        this.start();
    };
    SlickApp.prototype.compile = function () {
        var UrlConfiguration = this.GetAppConfiguration();
        this.boot(UrlConfiguration);
        return this.container;
    };
    SlickApp.prototype.start = function () {
        var init = url_join_1.urlJoin(window.location.pathname, window.location.search);
        this.history.push(init);
    };
    SlickApp.prototype.GetAppConfiguration = function () {
        var _this = this;
        var routeDetail = this.controllers.map(function (Controller) {
            return _this.getControllerRouteDetail(Controller);
        });
        var RouteNavigation = this.getViewNavigation(routeDetail);
        var UrlCompass = RouteNavigation.map(function (navigation) {
            var search = new route_parser_1.default(navigation.url);
            return [search, navigation];
        });
        return UrlCompass;
    };
    SlickApp.prototype.boot = function (urlPathReference) {
        var _this = this;
        var CreateApplication = function (viewProps) {
            if (viewProps === void 0) { viewProps = {}; }
            var view = new _this.base({
                target: _this.target,
                props: {
                    URLSTORE: main_1.URLSTORE,
                    PARAMSTORE: main_1.PARAMSTORE,
                    QUERYSTORE: main_1.QUERYSTORE,
                    viewProps: viewProps
                }
            });
            return view;
        };
        var Application = CreateApplication();
        this.history.listen(function (location, action) { return __awaiter(_this, void 0, void 0, function () {
            var tockTicker, tocker, pageRoute, pageURL, param, match, viewInfo, ControllerConstructor, controllerInstance, layoutPropsMethod, layoutProps, viewProps, viewComponent, templateProps_1, viewOptions_1, backup_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, tock_1.Tock()];
                    case 1:
                        _a.sent();
                        tocker = new Promise(function (r) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                tockTicker = r;
                                return [2];
                            });
                        }); });
                        tock_1.setTock(tocker);
                        pageRoute = url_join_1.urlJoin("/", location.pathname, location.search);
                        pageURL = url_join_1.urlJoin("/", location.pathname, location.search, location.hash);
                        match = urlPathReference.find(function (_a) {
                            var route = _a[0];
                            param = route.match(pageRoute.trim() || "/");
                            return param;
                        });
                        storeupdator_1.StoreUpdater.set().all({
                            url: pageURL,
                            param: param,
                            query: query_string_1.default.parse(location.search)
                        });
                        if (!match) {
                            Application.$set({
                                URLSTORE: main_1.URLSTORE,
                                PARAMSTORE: main_1.PARAMSTORE,
                                viewProps: {
                                    NotFound: this.Component404
                                }
                            });
                            tockTicker();
                        }
                        else {
                            viewInfo = match[1];
                            ControllerConstructor = viewInfo.controller;
                            controllerInstance = CallInjectedController_1.CallInjectedController(ControllerConstructor);
                            layoutPropsMethod = Reflect.getMetadata(constants_1.LAYOUT_PROP, ControllerConstructor);
                            layoutProps = is_1.default.string(layoutPropsMethod) ? this.getLayoutProps(controllerInstance, layoutPropsMethod) : {};
                            viewProps = this.getViewProps(controllerInstance, viewInfo).then(function (x) {
                                return x || {};
                            });
                            viewComponent = this.getViewComponent(ControllerConstructor, viewInfo);
                            templateProps_1 = {};
                            viewOptions_1 = this.getControllerOptions(viewInfo);
                            if (viewOptions_1) {
                                if ("layout" in viewOptions_1) {
                                    Object.assign(templateProps_1, { layout: viewOptions_1.layout });
                                }
                                if ("loading" in viewOptions_1) {
                                    Object.assign(templateProps_1, { loading: viewOptions_1.loading });
                                }
                            }
                            if ("error" in viewOptions_1) {
                                Object.assign(templateProps_1, { error: viewOptions_1.error });
                            }
                            else if (this.errorPage) {
                                Object.assign(templateProps_1, { error: this.errorPage });
                            }
                            Object.assign(templateProps_1, {
                                URLSTORE: main_1.URLSTORE,
                                PARAMSTORE: main_1.PARAMSTORE,
                                layout_props: layoutProps,
                                view: viewComponent
                            });
                            Object.assign(templateProps_1, { viewProps: viewProps });
                            backup_1 = Object.assign({}, templateProps_1);
                            promise_any_1.promiseAny([
                                viewProps,
                                new Promise(function (r) {
                                    return setTimeout(r, viewOptions_1.pause != void 0 ? viewOptions_1.pause : 400);
                                })
                            ])
                                .then(function () { return __awaiter(_this, void 0, void 0, function () {
                                var e_1, e_2;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 2, , 7]);
                                            return [4, Application.$set(templateProps_1)];
                                        case 1:
                                            _a.sent();
                                            tockTicker();
                                            return [3, 7];
                                        case 2:
                                            e_1 = _a.sent();
                                            _a.label = 3;
                                        case 3:
                                            _a.trys.push([3, 5, , 6]);
                                            Application.$destroy();
                                            Application = CreateApplication();
                                            return [4, Application.$set(templateProps_1)];
                                        case 4:
                                            _a.sent();
                                            tockTicker();
                                            return [3, 6];
                                        case 5:
                                            e_2 = _a.sent();
                                            tockTicker();
                                            return [3, 6];
                                        case 6: return [3, 7];
                                        case 7: return [2];
                                    }
                                });
                            }); })
                                .catch(function (e) {
                                console.error(e);
                                Object.assign(backup_1, {
                                    viewProps: Promise.resolve(Promise.reject(e))
                                });
                                Application.$set(backup_1);
                                tockTicker();
                            });
                        }
                        return [2];
                }
            });
        }); });
    };
    SlickApp.prototype.getControllerOptions = function (ViewActionDetail) {
        return getMetaData(constants_1.INJECT_OPTIONS, ViewActionDetail.controller) || {};
    };
    SlickApp.prototype.getViewComponent = function (controller, ViewActionDetail) {
        var view = Reflect.getMetadata(constants_1.VIEW_COMPONENT, controller, ViewActionDetail.method);
        this.ensureViewExist(view);
        return view;
    };
    SlickApp.prototype.getLayoutProps = function (Controller, method) {
        try {
            return Promise.resolve(CallInjectedView_1.CallInjectedView(Controller, method));
        }
        catch (e) {
            return Promise.resolve(Promise.reject(e));
        }
    };
    SlickApp.prototype.getViewProps = function (Controller, ViewActionDetail) {
        try {
            return Promise.resolve(CallInjectedView_1.CallInjectedView(Controller, ViewActionDetail.method));
        }
        catch (e) {
            return Promise.resolve(Promise.reject(e));
        }
    };
    Object.defineProperty(SlickApp.prototype, "controllers", {
        get: function () {
            return (this.options.controllers || []).map(function (x) { return x; });
        },
        enumerable: true,
        configurable: true
    });
    SlickApp.prototype.getViewNavigation = function (routeDetail) {
        var controllerNavigation = routeDetail.map(function (controllerSettings) {
            var controller = controllerSettings.controller;
            var route = controllerSettings.controller_path;
            var routes = controllerSettings.view_detail.map(function (viewSettings) {
                if (!viewSettings) {
                    throw new Error("Invalid view settings on " + controller);
                }
                var path = viewSettings.path;
                var method = viewSettings.method;
                var fullUrl = url_join_1.urlJoin(route, path).replace(/\/$/, "") || "/";
                return {
                    controller: controller,
                    method: method,
                    route: route,
                    path: path,
                    url: fullUrl
                };
            });
            return routes;
        });
        var RouteNavigation = this.flattenRoutes(controllerNavigation);
        return RouteNavigation;
    };
    SlickApp.prototype.flattenRoutes = function (controllerNavigation) {
        return controllerNavigation.reduce(function (a, b) {
            return b ? a.concat(b) : a;
        }, []);
    };
    SlickApp.prototype.getControllerRouteDetail = function (controller) {
        var controller_path = Reflect.getMetadata(constants_1.CONTROLLER_PATH, controller);
        var view_detail = Object.entries(controller.prototype)
            .map(function (_a) {
            var method = _a[0], value = _a[1];
            if (Reflect.hasMetadata(constants_1.VIEW_PATH, controller, method)) {
                var path = Reflect.getMetadata(constants_1.VIEW_PATH, controller, method);
                return {
                    path: path,
                    method: method
                };
            }
            else {
                return null;
            }
        })
            .filter(function (x) { return !!x; });
        var routeDetail = {
            controller: controller,
            controller_path: controller_path,
            view_detail: view_detail
        };
        return routeDetail;
    };
    SlickApp.prototype.ensureViewExist = function (view) {
        if (!view) {
            throw new Error("View doesn't exist");
        }
    };
    return SlickApp;
}());
exports.SlickApp = SlickApp;
