import { FactoryProvider } from "../Provider";
import { IContainer } from "./IContainer";
export declare type Scope = "Request" | "Transient" | "Singleton";
export declare class Container implements IContainer {
    private providers;
    cache: {
        Request: Map<any, Map<any, any>>;
        Singleton: Map<any, any>;
    };
    constructor(providers: FactoryProvider[]);
    isBound(identifier: any): boolean;
    get<T = any>(identifier: any): T | PromiseLike<T>;
    build(identifier: any, requestID: string): any;
    private buildAsSingleton;
    buildAsRequest(provider: FactoryProvider, requestID: string): any;
    buildAsTransient(provider: FactoryProvider, requestID: any): any;
    private printIdentifier;
    private getScopeOfInjects;
    private scopePicker;
}
export declare class ScopePicker {
    static pickList(...scopes: Scope[]): "Request" | "Singleton" | "Transient";
    static pick(scope1: Scope, scope2: Scope, options?: string[]): "Request" | "Singleton" | "Transient";
}
