"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var check = __importStar(require("../../provider/check"));
var ProviderFromConstructor_1 = require("./ProviderFromConstructor");
var ProviderFromValue_1 = require("./ProviderFromValue");
var Container_1 = require("../builder/Container");
var ContainerBuilder = (function () {
    function ContainerBuilder() {
        this.providers = [];
    }
    ContainerBuilder.prototype.bind = function (provider) {
        return this.add(provider);
    };
    ContainerBuilder.prototype.add = function (provider) {
        if (check.isConstructor(provider)) {
            this.providers.push(ProviderFromConstructor_1.ProviderFromConstructor(provider));
        }
        else if (check.IsUseValue(provider)) {
            this.providers.push(ProviderFromValue_1.ProviderFromValue(provider));
        }
        else if (check.IsUseFactory(provider)) {
            provider.inject = provider.inject || [];
            this.providers.push(provider);
        }
        else {
            throw new Error("not a valid provider");
        }
        return this;
    };
    ContainerBuilder.getContainer = function (builder) {
        return new Container_1.Container(builder.providers);
    };
    return ContainerBuilder;
}());
exports.ContainerBuilder = ContainerBuilder;
