"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var design_1 = require("../builder/design");
var constants_1 = require("../../types/constants");
function ProviderFromConstructor(constructor) {
    var inject = Reflect.getMetadata(design_1.Design.Parameters, constructor) || [];
    var alter = Reflect.getMetadata(constants_1.PARAMETER, constructor) || [];
    if (alter) {
        alter.forEach(function (_a) {
            var index = _a.index, identifier = _a.identifier;
            inject.splice(index, 1, identifier);
        });
    }
    return {
        provide: constructor,
        inject: inject,
        useFactory: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return Reflect.construct(constructor, args);
        },
        scope: (Reflect.getMetadata(constants_1.INJECT_OPTIONS, constructor) || {}).scope || "Singleton"
    };
}
exports.ProviderFromConstructor = ProviderFromConstructor;
