"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../types/constants");
var design_1 = require("../container/builder/design");
function Controller(path, options) {
    if (path === void 0) { path = "/"; }
    if (options === void 0) { options = {}; }
    path = path === "" ? "/" : path;
    return function (constructor) {
        Reflect.defineMetadata(constants_1.CONTROLLER_PATH, path, constructor);
        if (options) {
            Reflect.defineMetadata(constants_1.INJECT_OPTIONS, options, constructor);
        }
        var inject = Reflect.getMetadata(design_1.Design.Parameters, constructor) || [];
        inject = inject.map(function (x, index) {
            return {
                index: index,
                identifier: x
            };
        });
        return constructor;
    };
}
exports.Controller = Controller;
