"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../types/constants");
var providerName_1 = require("../provider/providerName");
function Inject(identifier, action) {
    if (action === void 0) { action = function (x) { return x; }; }
    return function (target, method, parameterIndex) {
        target = method ? target.constructor : target;
        var params = (method ? Reflect.getMetadata(constants_1.PARAMETER, target, method) : Reflect.getMetadata(constants_1.PARAMETER, target)) || [];
        params.push({
            index: parameterIndex,
            identifier: identifier,
            action: action
        });
        if (method) {
            Reflect.defineMetadata(constants_1.PARAMETER, params, target, method);
        }
        else {
            Reflect.defineMetadata(constants_1.PARAMETER, params, target);
        }
    };
}
exports.Inject = Inject;
function Param(name) {
    var transform = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        transform[_i - 1] = arguments[_i];
    }
    var shaper = [function (x) { return name ? x[name] : x; }].concat(transform);
    function shape(x) {
        return shaper.reduce((function (x, method) {
            return method(x);
        }), x);
    }
    return Inject(providerName_1.ParamService, shape);
}
exports.Param = Param;
function Query(name) {
    var transform = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        transform[_i - 1] = arguments[_i];
    }
    var shaper = [function (x) { return name ? x[name] : x; }].concat(transform);
    function shape(x) {
        return shaper.reduce((function (x, method) {
            return method(x);
        }), x);
    }
    return Inject(providerName_1.QueryService, shape);
}
exports.Query = Query;
function History(name) {
    return Inject(providerName_1.HistoryService);
}
exports.History = History;
