"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../types/constants");
var is_1 = __importDefault(require("@sindresorhus/is"));
function LayoutProps(target, method, decorator) {
    if (!method) {
        throw new Error("LayoutProps can only be used on a method");
    }
    target = method ? target.constructor : target;
    var method_name = Reflect.getMetadata(constants_1.LAYOUT_PROP, target);
    if (!is_1.default.nullOrUndefined(method_name)) {
        throw new Error("LayoutProps can only be used once per a class");
    }
    Reflect.defineMetadata(constants_1.LAYOUT_PROP, method, target);
}
exports.LayoutProps = LayoutProps;
