"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var providerName_1 = require("./providerName");
var store_1 = require("svelte/store");
var main_1 = require("../stores/main");
var history_1 = require("../stores/history");
exports.ParamProvider = {
    provide: providerName_1.ParamService,
    useFactory: function () {
        return store_1.get(main_1.PARAMSTORE);
    },
    scope: "Request"
};
exports.QueryProvider = {
    provide: providerName_1.QueryService,
    useFactory: function () {
        return store_1.get(main_1.QUERYSTORE);
    },
    scope: "Request"
};
exports.HistoryProvider = {
    provide: providerName_1.HistoryService,
    useFactory: function () {
        return store_1.get(history_1.historyStore);
    },
    scope: "Request"
};
exports.ApplicationProviders = [exports.ParamProvider, exports.QueryProvider, exports.HistoryProvider];
