"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var main_1 = require("./main");
var StoreUpdater = (function () {
    function StoreUpdater() {
        this.queryStore = main_1.QUERYSTORE;
        this.paramStore = main_1.PARAMSTORE;
        this.urlStore = main_1.URLSTORE;
    }
    StoreUpdater.prototype.updateQuery = function (query) {
        this.queryStore.update(function () { return query; });
    };
    StoreUpdater.prototype.updateUrl = function (url) {
        this.urlStore.update(function () { return url; });
    };
    StoreUpdater.prototype.updateParam = function (param) {
        this.paramStore.update(function () { return param; });
    };
    StoreUpdater.prototype.all = function (_a) {
        var param = _a.param, url = _a.url, query = _a.query;
        this.updateParam(param);
        this.updateQuery(query);
        this.updateUrl(url);
    };
    StoreUpdater.set = function () {
        return new StoreUpdater();
    };
    return StoreUpdater;
}());
exports.StoreUpdater = StoreUpdater;
